%VG21 uloha 1 (Vypocet vysek}
%RSC (rsc@email.cz)

clear %vymazani pameti
clc %smazani obrazovky

%tic;%stopky

%================================+
vg21_vysky51 % vstupni soubor    |
%================================+
%vstupni soubor musi mit priponu *.m (to .m se tady nepise)
% a nemela by tam byt jina tecka, jinak to zlobi ...


fid = fopen('vg21_u01.txt','w'); %vytvoreni *.txt souboru pro vystup

clc;
ro = 180/pi;

fprintf(fid,'VG21 - uloha 1\n');
fprintf(fid,'--------------\n\n');


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fprintf(fid,'============================================================\n');
fprintf(fid,'prevod merenych prevyseni na normalni (Molodenskeho)\n');
fprintf(fid,'============================================================\n');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%stredni vyska [m]
H_str = [
    (body_L(1,2) + body_L(2,2)) / 2
    (body_L(2,2) + body_L(3,2)) / 2
    (body_L(3,2) + body_L(4,2)) / 2
    (body_L(4,2) + body_L(5,2)) / 2
    (body_L(5,2) + body_L(6,2)) / 2
    (body_L(6,2) + body_L(1,2)) / 2
    (body_L(7,2) + body_L(1,2)) / 2
    (body_L(7,2) + body_L(2,2)) / 2
    (body_L(7,2) + body_L(3,2)) / 2
    (body_L(7,2) + body_L(4,2)) / 2
    (body_L(7,2) + body_L(5,2)) / 2
    (body_L(7,2) + body_L(6,2)) / 2
    (body_L(1,2) + body_L(3,2)) / 2
    (body_L(3,2) + body_L(5,2)) / 2
    (body_L(5,2) + body_L(1,2)) / 2 
];

%delta fi ['']
D_fi = -ro*3600*[
    body_L(1,3) - body_L(2,3)
    body_L(2,3) - body_L(3,3)
    body_L(3,3) - body_L(4,3)
    body_L(4,3) - body_L(5,3)
    body_L(5,3) - body_L(6,3)
    body_L(6,3) - body_L(1,3)
    body_L(7,3) - body_L(1,3)
    body_L(7,3) - body_L(2,3)
    body_L(7,3) - body_L(3,3)
    body_L(7,3) - body_L(4,3)
    body_L(7,3) - body_L(5,3)
    body_L(7,3) - body_L(6,3)
    body_L(1,3) - body_L(3,3)
    body_L(3,3) - body_L(5,3)
    body_L(5,3) - body_L(1,3)
];

%normalni ortometricka korekce [mm]
NOK = -0.0000254 * H_str .* D_fi;

gF = 100000 * body_L(:,4) + 0.3086 * body_L(:,2);

gFs = [
    (gF(1) + gF(2)) / 2
    (gF(2) + gF(3)) / 2
    (gF(3) + gF(4)) / 2
    (gF(4) + gF(5)) / 2
    (gF(5) + gF(6)) / 2
    (gF(6) + gF(1)) / 2
    (gF(7) + gF(1)) / 2
    (gF(7) + gF(2)) / 2
    (gF(7) + gF(3)) / 2
    (gF(7) + gF(4)) / 2
    (gF(7) + gF(5)) / 2
    (gF(7) + gF(6)) / 2
    (gF(1) + gF(3)) / 2
    (gF(3) + gF(5)) / 2
    (gF(5) + gF(1)) / 2
];

%gama (thov zrychlen [mGal])
gama = 978030 * (1 + 0.005302 * (sin(body_L(:,3)).^2)-0.000007 * (sin((2*body_L(:,3)))).^2);

%gama stredn (thov zrychlen [mGal])
gama_s = [
    (gama(1) + gama(2)) / 2
    (gama(2) + gama(3)) / 2
    (gama(3) + gama(4)) / 2
    (gama(4) + gama(5)) / 2
    (gama(5) + gama(6)) / 2
    (gama(6) + gama(1)) / 2
    (gama(7) + gama(1)) / 2
    (gama(7) + gama(2)) / 2
    (gama(7) + gama(3)) / 2
    (gama(7) + gama(4)) / 2
    (gama(7) + gama(5)) / 2
    (gama(7) + gama(6)) / 2
    (gama(1) + gama(3)) / 2
    (gama(3) + gama(5)) / 2
    (gama(5) + gama(1)) / 2
];

DgF = gFs - gama_s;

%C_gFgama
KAT = 0.0010193 * DgF .* dh_L(:,3);

dh_opr = [dh_L(:,3) + NOK/1000 + KAT/1000];


%dh_L(:,1:2) NOK KAT dH_opr

fprintf(fid,'\n+-----------+--------------------+--------------------------+\n');
fprintf(fid,'|prevyseni  |   korekce [mm]     |          prevyseni [m]   |\n');
fprintf(fid,'| z    na   |  NOK        KAT    |    meren        normln|\n');
fprintf(fid,'+-----------+--------------------+--------------------------+\n');

for i=1:15
   fprintf(fid,'  %.f    %.f     %+6.2f     %+6.2f      %9.5f      %9.5f \n',dh_L(i,1:2),NOK(i),KAT(i),dh_L(i,3),dh_opr(i));
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fprintf(fid,'\n\n============================================================\n');
fprintf(fid,'vyrovnani 2. etapy\n');
fprintf(fid,'============================================================\n\n');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

body_L(1,2) = H1fix;%zahrnut presn vsky bodu 1


A = [
%bod 1  2  4  5  6  8  9
    -1  1  0  0  0  0  0  %1 2
     0 -1  0  0  1  0  0  %2 6
     0  0  0  0 -1  0  1  %6 9
     0  0  0  0  0  1 -1  %9 8
     0  0  1  0  0 -1  0  %8 4
     1  0 -1  0  0  0  0  %4 1
     1  0  0 -1  0  0  0  %5 1
     0  1  0 -1  0  0  0  %5 2
     0  0  0 -1  1  0  0  %5 6
     0  0  0 -1  0  0  1  %5 9
     0  0  0 -1  0  1  0  %5 8
     0  0  1 -1  0  0  0  %5 4
    -1  0  0  0  1  0  0  %1 6
     0  0  0  0 -1  1  0  %6 8
     1  0  0  0  0 -1  0  %8 1
     1  0  0  0  0  0  0  %bod 1
];

l_mer = [dh_opr' H1fix]';

l = l_mer;  %Vec l'

m_mer = [sig0 * (dh_L(:,4)).^0.5'    1]'; %Vec apriornch str.chyb [m]

p_mer = [1./dh_L(:,4)'    1]'; %Vec vah

P = diag(p_mer); %Mat P

%vyrovnn
N2 = A' * P * A;
N2o = N2;%puvodni N2
Q2 = inv(N2);

dx = Q2 * A' * P * l;%vyrovnan vsky

v1 = A * dx - l;%opravy prevsen (Vec v1)

%serazeni bodu 2.etapy podle cisel (vlastne jen kvuli cslum bodu...)
body_L2 = [
    body_L(1,:)
    body_L(2,:)
    body_L(6,:)
    body_L(7,:)
    body_L(3,:)
    body_L(5,:)
    body_L(4,:)
];

vyr_body2et = dx;

%

vyr_dh_L = dh_opr + v1(1:15);%vyrovnan prevysen

prev2x = [
    vyr_body2et(2) - vyr_body2et(1)
    vyr_body2et(5) - vyr_body2et(2)
    vyr_body2et(7) - vyr_body2et(5)
    vyr_body2et(6) - vyr_body2et(7)
    vyr_body2et(3) - vyr_body2et(6)
    vyr_body2et(1) - vyr_body2et(3)
    vyr_body2et(1) - vyr_body2et(4)
    vyr_body2et(2) - vyr_body2et(4)
    vyr_body2et(5) - vyr_body2et(4)
    vyr_body2et(7) - vyr_body2et(4)
    vyr_body2et(6) - vyr_body2et(4)
    vyr_body2et(3) - vyr_body2et(4)
    vyr_body2et(5) - vyr_body2et(1)
    vyr_body2et(6) - vyr_body2et(5)
    vyr_body2et(1) - vyr_body2et(6)
];

v2 = prev2x - l_mer(1:15);  %Vec v2'

%

s2 = 15 - 6 + 1;%pocet nadbytecnch meren (15-6 bez bodu 1 a +1 je podminka pro bod 1 v Mat A)

%m02 = ((v1' * P * v1) / (s2))^0.5; %s bodem 1 v Mat A
m02 = ((v2' * P(1:15,1:15) * v2) / (s2))^0.5; %bez bodu 1 v Mat A

%
m_vyr_body2et = sig0 * diag(Q2).^0.5; %str.ch.vyrovnanch bodu [m]
%m_vyr_body2et = m02 * diag(Q2).^0.5; %str.ch.vyrovnanch bodu [m]

m_vyr_dh_L = sig0 * diag(A * Q2 * A').^0.5; %str.ch.vyrovnanch prevsen [m]
%m_vyr_dh_L = m02 * diag(A * Q2 * A').^0.5; %str.ch.vyrovnanch prevsen [m]
%

fprintf(fid,'------------------------------------------------\n');
fprintf(fid,'Vyrovnan vsky bodu 2. etapy\n');
fprintf(fid,'------------------------------------------------\n');
fprintf(fid,'  bod     vyska [m]        mi [mm]\n');
fprintf(fid,'------------------------------------------------\n');

for i=1:7
   fprintf(fid,'   %.f      %9.5f         %.2f\n',body_L2(i,1),vyr_body2et(i),1000*m_vyr_body2et(i));
end

fprintf(fid,'+-------------------------------------+------+-----------------+------------------+\n');
fprintf(fid,'|           prevyseni [m]             | vha |   opravy [mm]   | apri     apost   |\n');
fprintf(fid,'| z    na     normaln     vyrovnan  |  pi  |   v1       v2   | mi [mm]  mi [mm] |\n');
fprintf(fid,'+-------------------------------------+------+-----------------+------------------+\n');

for i=1:15
   fprintf(fid,'  %.f    %.f     %9.5f     %9.5f    %.2f   %+.3f   %+.3f    %.2f     %.2f\n',dh_L(i,1:2),dh_opr(i),vyr_dh_L(i),p_mer(i),1000*v1(i),1000*v2(i),1000*m_mer(i),1000*m_vyr_dh_L(i));
end

fprintf(fid,'\naposteriorn m0 pro 2.etapu = %.2f mm\n',1000*m02);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fprintf(fid,'\n\n============================================================\n');
fprintf(fid,'spolecn vyrovnn 1. a 2. etapy\n');
fprintf(fid,'============================================================\n\n');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%LEVY BLOK ---------------------------------------------------------------------------------------

C2 = [
%   1 2 3 4 5 6 7 8 9 10
    1 0 0 0 0 0 0 0 0 0
    0 1 0 0 0 0 0 0 0 0
    0 0 0 1 0 0 0 0 0 0
    0 0 0 0 1 0 0 0 0 0
    0 0 0 0 0 1 0 0 0 0
    0 0 0 0 0 0 0 1 0 0
    0 0 0 0 0 0 0 0 1 0
];

%expandovan N2
N2E = C2' * N2o * C2;

%expandovan x2
x2E = C2' * dx;

%A'Pl = b2 (expandovan b2)
b2E = N2E * x2E;


%PRAVY BLOK ---------------------------------------------------------------------------------------

N1o = N;%puvodni N1

%odstranen constrainu
b = [0 0 0 0 0 0 1];
p = 1; %vha fixovanho bodu

%Mat N
N1 = N - b' * p * b;

x1 = vyrH_R(:,2);
b1 = N * x1;

%Vec b
b1_odc = b1 - b' * p * 292.34090;


%expanze
C1 = [
%   1 2 3 4 5 6 7 8 9 10
    0 1 0 0 0 0 0 0 0 0
    0 0 1 0 0 0 0 0 0 0
    0 0 0 0 0 0 1 0 0 0
    0 0 0 0 0 0 0 0 0 1
    0 0 0 0 0 0 0 0 1 0
    0 0 0 0 1 0 0 0 0 0
    0 0 0 0 0 1 0 0 0 0
];

N1E = C1' * N1 * C1;

%A'Pl = b
b1E = C1' * b1_odc;

%SEKVENCNI VYROVNANI ---------------------------------------------------------------------------------------

%A'Pl (=b) pro sekvencni vyrovnani
    b = b1E + b2E;

%N pro sekvencni vyrovnani 
    N = N1E + N2E;
    
%vysledne vysky
    vyr_body = inv(N) * b;


m_vyr_H_all = sig0 * diag(inv(N)).^0.5; %str.ch.vsech vyrovnanch vsek


fprintf(fid,'-----------------------------\n');
fprintf(fid,'  bod    vska [m]    mi [mm]\n');
fprintf(fid,'-----------------------------\n');

for i=1:10
    fprintf(fid,'  %3.f    %.5f     %.2f\n',i,vyr_body(i),1000*m_vyr_H_all(i));
end


%aposteriorn m0

%etapa 1
x1o = vyrH_R(:,2);
N1o;
b1o = -N1o * x1o;
s1 = freedom;
m01 = sig_apost;

%xT*ATPl
%x1o' * b1o

%lTPl
%m01^2 * s1 - x1o' * b1o

%etapa 2
x2o = dx;
N2o;
b2o = -N2o * x2o;
s2;
m02;

%xT*ATPl
%x2o' * b2o

%lTPl
%m02^2 * s2 - x2o' * b2o

%etapa 1 i 2
s12 = 4;



m0 = ((((x1o' * b1o)+(x2o' * b2o)) + ((m01^2 * s1 - x1o' * b1o)+(m02^2 * s2 - x2o' * b2o))) / (s1 + s2 + s12) )^0.5;

fprintf(fid,'\ncelkov aposteriorn m0 = %.2f mm\n',1000*m0);


fclose(fid);
fprintf('\n\nCseln vsledky jsou ulozeny v souboru "vg21_u01.txt"\n v pracovnm adresri\n\n');